{% extends "users/userspace.html" %}

{% load template_utils %}

{% block scripts %}
<script>
    $(document).ready(function() {
        // Fonction pour cocher ou décocher toutes les inscriptions d'une ferme
        function toggleFarmInscriptions(farm_id, user_id, checked) {
            $(`.inscriptions_check[farm_id="${farm_id}"][user_id="${user_id}"]`).prop("checked", checked);
        }

        // Fonction pour cocher ou décocher toutes les fermes d'un utilisateur
        function toggleUserFarms(user_id, checked) {
            $(`.farm_check[user_id="${user_id}"]`).prop("checked", checked);
            $(`.inscriptions_check[user_id="${user_id}"]`).prop("checked", checked);
        }

        // Gestionnaire de changement pour les cases à cocher des utilisateurs
        $(".user_check").change(function() {

            let user_id = $(this).attr("user_id");
            let checked = $(this).prop("checked");
            toggleUserFarms(user_id, checked);

            $("#form").submit();
        });

        // Gestionnaire de changement pour les cases à cocher des fermes
        $(".farm_check").change(function() {
            let farm_id = $(this).attr("farm_id");
            let user_id = $(this).attr("user_id");
            let checked = $(this).prop("checked");
            toggleFarmInscriptions(farm_id, user_id, checked);

            // Vérifier si toutes les fermes de l'utilisateur sont cochées et cocher/décocher automatiquement l'utilisateur
            let allFarmsChecked = $(`.farm_check[user_id="${user_id}"]:checked`).length === $(`.farm_check[user_id="${user_id}"]`).length;
            $(`#user_${user_id}`).prop("checked", allFarmsChecked);

            $("#form").submit();
        });

        // Gestionnaire de changement pour les cases à cocher des inscriptions
        $(".inscriptions_check").change(function() {
            let farm_id = $(this).attr("farm_id");
            let user_id = $(this).attr("user_id");

            // Vérifier si toutes les inscriptions de la ferme sont cochées et cocher/décocher automatiquement la ferme
            let allInscriptionsChecked = $(`.inscriptions_check[farm_id="${farm_id}"][user_id="${user_id}"]:checked`).length === $(`.inscriptions_check[farm_id="${farm_id}"][user_id="${user_id}"]`).length;
            $(`.farm_check[farm_id="${farm_id}"][user_id="${user_id}"]`).prop("checked", allInscriptionsChecked);

            // Vérifier si toutes les fermes de l'utilisateur sont cochées et cocher/décocher automatiquement l'utilisateur
            let allFarmsChecked = $(`.farm_check[user_id="${user_id}"]:checked`).length === $(`.farm_check[user_id="${user_id}"]`).length;
            $(`#user_${user_id}`).prop("checked", allFarmsChecked);

            $("#form").submit();
        });

        // Cocher les fermes et les utilisateurs au chargement de la page
        $(".farm_check").each(function() {
            let farm_id = $(this).attr("farm_id");
            let user_id = $(this).attr("user_id");
            let checked = $(`.inscriptions_check[farm_id="${farm_id}"][user_id="${user_id}"]:checked`).length === $(`.inscriptions_check[farm_id="${farm_id}"][user_id="${user_id}"]`).length;
            $(this).prop("checked", checked);
        });

        $(".user_check").each(function() {
            let user_id = $(this).attr("user_id");
            let checked = $(`.farm_check[user_id="${user_id}"]:checked`).length === $(`.farm_check[user_id="${user_id}"]`).length;
            $(this).prop("checked", checked);
        });
    });
</script>
{% endblock %}

{% block content %}
    <div class="container px-5 my-5">
        <h1>Liste émargement</h1>

        <h4>Distribution du {{ distribution.date_heure|date:"d/m/Y" }} à {{ distribution.date_heure|date:"H:i" }}</h4>

        {% if form.errors %}
        <div class="alert alert-danger" role="alert">
            <p class="alert-heading"><i class="mx-1 fas fa-exclamation-circle"></i>Erreurs :</p>
            {% for fieldname, errors in form.errors.items %}
                {% if fieldname != "__all__" %}
                    {{ fieldname }} :
                {% endif %}
                <ul class="mb-0">
                    {% for error in errors %}
                        <li>{{ error }}</li>
                    {% endfor %}
                </ul>
            {% endfor %}
        </div>
        {% endif %}

        <div class="pagination justify-content-center m-3 flex-wrap">
            <ul class="pagination justify-content-center flex-wrap">
                <li class="mt-1 page-item disabled">
                    <a class="page-link">Nom de famille :</a>
                </li>
                {% for letter in "ABCDEFGHIJKLMNOPQRSTUVWXYZ" %}
                    <li class="mt-1 page-item {% if request.GET.page|default:'A'|upper == letter %}active{% else %}{% endif %}">
                        <a class="page-link" href="?page={{letter}}">{{letter}}</a>
                    </li>
                {% endfor %}
            </ul>
        </div>

        <form method="post" action="#" id="form">
            {% csrf_token %}
            <input type="hidden" name="page" value="{{ request.GET.page }}">
        <div class="accordion mt-3" id="accordionUsers">
            {% for user in form.inscriptions %}
            <div class="accordion-item">
                <h2 class="accordion-header">
                    <button class="accordion-button collapsed" type="button" data-bs-toggle="collapse" data-bs-target="#collapse{{ forloop.counter }}" aria-expanded="false" aria-controls="collapse{{ forloop.counter }}">
                        <input type="checkbox" id="user_{{user.id}}" user_id="{{user.id}}" class="form-check-input me-3 user_check"> 
                        {{ user.last_name|upper }} {{ user.first_name }}  ({{ user.email }})
                    </button>
                </h2>
                <div id="collapse{{ forloop.counter }}" class="accordion-collapse collapse" aria-labelledby="heading{{ forloop.counter }}" data-bs-parent="#accordionUsers">
                    <div class="accordion-body">
                        {% for ferme in form.inscriptions|get_item:user %}
                            <div class="mb-2">
                            <input type="checkbox" class="form-check-input me-3 farm_check" farm_id={{ferme.id}} user_id={{user.id}}><span class="fw-bold">{{ ferme.nom }}</span>
                            <ul>
                            {% for inscription in form.inscriptions|get_item:user|get_item:ferme %}
                            {% with fieldname="inscription_"|strcat:inscription.id%}
                            {% with field=form|get_item:fieldname %}
                            <li>{{field}} {{field.label}}</li>
                            {% endwith %}
                            {% endwith %}
                            {% endfor %}
                            </ul>
                            </div>
                        {% endfor %}

                    </div>
                </div>
            </div>
            {% endfor %}
        </div>
    </form>


    </div>
{% endblock %}
